<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

// В ходе подключения тестового доступа к платежному шлюзу Продавец направляет в службу поддержки Payture запрос на подключение. В запросе в том числе следует указать:
// выбранный метод нотификаций - HTTP POST запрос
// адрес получения нотификаций - http://www.вашсайт.ru/index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&payture=1&tmpl=component
// для каких операций необходимо выполнять оповещение выбранным методом нотификаций - apim/Pay

class plgVMPaymentPayture extends vmPSPlugin
{
	public static $_this = false;
	public static $flag = false;
	public $sessionID = '';
	public $paystate = '';
	public $curlerror = '';

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}

    protected function getVmPluginCreateTableSQL()
    {
		return $this->createTableSQL('Payment payture Table');
    }
    
    function getTableSQLFields()
    {
		$SQLfields = array(
			'id' 							=> 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id' 			=> 'int(1) UNSIGNED', 
			'order_number'              	=> 'char(64)',
			'virtuemart_paymentmethod_id' 	=> 'mediumint(1) UNSIGNED',
			'payment_name' 					=> 'char(255) NOT NULL DEFAULT \'\' ',
			'payment_order_total'       	=> 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
			'payment_currency' 				=> 'char(3) ',
			'cost_per_transaction' 			=> 'decimal(10,2)',
			'cost_percent_total' 			=> 'char(10)',
			'tax_id' 						=> 'smallint(1)',
			'sessionID'						=> 'varchar(64) NOT NULL DEFAULT \'\' '
		);

		return $SQLfields;
    }
    
    function plgVmConfirmedOrder($cart, $order) 
    {
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
		
		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
	    if (!class_exists('VirtueMartModelCurrency'))
	    {
	    	require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
	    }	    
		$new_status = $method->status_pending;		    	
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false), 2);
		$cnt = count($order['items']);
		if($cnt==1)	$prod = $order['items'][0]->order_item_name;
		else $prod = "Заказ № " . $order['details']['BT']->order_number;
		
		//Формирование POST заголовка для отправки на платежную систему	
		$post_variables = Array(
			'SessionType'		=> "Pay",
			'OrderId'			=> $order['details']['BT']->virtuemart_order_id,
			'Amount'			=> $totalInPaymentCurrency*100,
			'Total'				=> $totalInPaymentCurrency,
			'Description'		=> mb_substr($prod, 0, 50),
			'Product'			=> 'товара(ов)',
			'IP'				=> isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : '1.1.1.1',
			'Url'				=> JURI::root().'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&payture=1&orderid='.$order['details']['BT']->virtuemart_order_id
		);

	   	$url = $method->server;
		$this->sessionID='';
		$this->curlerror='';
		$ar = array();
		$ar['Key'] = $method->merchantkey;
		$ar['Data'] ='';
		$d = '';
		foreach ($post_variables as $name => $value) {
			$ar['Data'] .= $d.$name.'='.$value;
			$d = ';';
		}
		$ar['Data'] = urlencode($ar['Data']);
		 
		$this->doCurl($url.'apim/Init', $ar);
		if(!$this->sessionID) {
			$html = '<p>Извините, ошибка связи с сервисом приема платежей. '.$this->curlerror.'</p>';
			vRequest::setVar ('html', $html);
			return NULL;
		} else {
			$dbValues = array();
			$this->_virtuemart_paymentmethod_id      = $order['details']['BT']->virtuemart_paymentmethod_id;
			$dbValues['payment_name']                = $this->renderPluginName($method);
			$dbValues['order_number']                = $order['details']['BT']->order_number;
			$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
			$dbValues['cost_per_transaction']        = $method->cost_per_transaction;
			$dbValues['cost_percent_total']          = $method->cost_percent_total;
			$dbValues['payment_currency']            = $currency_code_3 ;
			$dbValues['payment_order_total']         = $totalInPaymentCurrency;
			$dbValues['tax_id']                      = $method->tax_id;
			$dbValues['sessionID']                   = $this->sessionID;
			$this->storePSPluginInternalData($dbValues);

			$send_pending = 0;
			if(isset($method->send_pending)) $send_pending=$method->send_pending;
			
			$html = '<form action="' . $url . 'apim/Pay" method="post" name="vm_payture_form">';
			$html.= '<input type="hidden" name="SessionId" value="'.$this->sessionID.'" />';
			$html.= '<p>Вы будете автоматически перенаправлены на сервис оплаты. Если этого не произошло, <input type="submit" class="btn" value="Нажмите здесь" /></p>';
			$html.= '</form>';

			$html.= ' <script type="text/javascript">';
			$html.= ' document.vm_payture_form.submit();';
			$html.= ' </script>';
			if($send_pending) {
				$modelOrder = VmModel::getModel ('orders');
				$order['order_status'] = $new_status;
				$order['customer_notified'] = 1;
				$order['comments'] = '';
				$modelOrder->updateStatusForOneOrder ($order['details']['BT']->virtuemart_order_id, $order, TRUE);
			} else {
				$this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $method->payment_name, $new_status);
			}
			vRequest::setVar ('html', $html);
			return null;
		}
    } 

	public function doCurl($url, $form, $call='init')
	{
		$paramstr = http_build_query($form);
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 35);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 Firefox/1.0.7");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HEADER, FALSE);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $paramstr);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSLVERSION,1);
		$result = curl_exec($ch);
		$this->curlerror = curl_error( $ch );
		curl_close($ch);
		if (!$result) {
		    $this->logInfo('payture error: ' . $this->curlerror);
		} else {
		    $this->logInfo($result);

            $xml = simplexml_load_string($result);
            if ((bool)$xml["Success"][0] == true) {
				if($call=='init') { 
					if ($xml["SessionId"][0]) {
						$code      = 0;
						$amount    = $xml["Amount"][0];
						$order_id  = $xml["OrderId"][0];
						$this->sessionID = $xml["SessionId"][0];
					}
				}
				if($call=='paystatus') { 
					if ($xml["State"][0]) {
						$code      = 0;
						$amount    = $xml["Amount"][0];
						$order_id  = $xml["OrderId"][0];
						$this->paystate = $xml["State"][0];
					}
				}
            } else {
                $code = $xml["ErrCode"][0];
                $this->logInfo($xml["ErrCode"][0]);
            }

        }
	}	
	
	//Отображение информации о заказе в админке    
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id))
		{
	    	return null;
		}
    
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject()))
		{
	    	vmWarn(500, $q . " " . $db->getErrorMsg());
	    	return '';
		}
		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist table">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('VMPAYMENT_PAYTURE', $paymentTable->payment_name);
		$html .= '</table>' . "\n";
		return $html;
    }

	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {

		if (preg_match ('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr ($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}

    protected function checkConditions($cart, $method, $cart_prices)
    {
		    return true;
    }

	//Возврат покупателя в интернет-магазин после успешной оплаты.   
    function plgVmOnPaymentResponseReceived(  &$html)
    {
		if(!JFactory::getApplication()->input->getInt('payture',0)) {
			return NULL;
		}
		if(self::$flag) return null;
		$payment_data = array();
		$payment_data['orderid'] = JFactory::getApplication()->input->get('orderid');
		if(!isset($payment_data['orderid'])) return null;
		vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
		/****************************************************************/
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$virtuemart_order_id = $payment_data['orderid'];
	    if ($virtuemart_order_id)
	    {
			//проверим статус платежа
			$payment = $this->getDataByOrderId($virtuemart_order_id);
			$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
			$ar = array();
			$ar['Key'] = $method->merchantkey;
			$ar['OrderId'] = $virtuemart_order_id;
			$this->paystate='';
			$this->curlerror='';
			$this->doCurl($method->server.'apim/PayStatus', $ar, 'paystatus');
			if (!class_exists('VirtueMartCart'))
			{
				require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
			}
			$cart = VirtueMartCart::getCart();
			if($this->paystate=='Charged') {
				$html = "Оплата прошла успешно";
				if (!class_exists('VirtueMartModelOrders'))
				{
					require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
				}
				$order_model = new VirtueMartModelOrders();
				$order_info = $order_model->getOrder($virtuemart_order_id);
				$new_status = $method->status_success;
				if($order_info['details']['BT']->order_status!=$new_status) {
					$order = array();
					$order['order_status'] = $new_status;
					$order['customer_notified'] =1;
					$order['comments']='payture';
					$order_model->updateStatusForOneOrder($virtuemart_order_id, $order, true);
				}

				$cart->emptyCart();
			}
			if($this->paystate=='Error') {
				$html = "Оплата не прошла. Вы можете вернуться в корзину и повторить оплату.";
			}
			if($this->paystate=='Rejected') {
				$html = "Оплата не прошла. Транзакция отклонена платежной системой.";
			}
			if(!$html) {
				$html = "Ожидаем подтверждения оплаты от банка.";
				$cart->emptyCart();
			}
			self::$flag = true; // а это, чтобы несколько раз одно и то же не делать
			return true;
		}
		return null;
    }

	function plgVmOnUserPaymentCancel()
    {
    	return null;
    }
	
	function plgVmOnPaymentNotification()
    {
		if(!JFactory::getApplication()->input->getInt('payture',0)) {
			return NULL;
		}
		//Изменение статуса заказа на Confirmed после оплаты счета
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$pay_data = array();
		$pay_data['orderid'] = JFactory::getApplication()->input->get('orderid');
		$pay_data['Amount'] = JFactory::getApplication()->input->get('Amount')/100;
		$pay_data['Success'] = JFactory::getApplication()->input->get('Success');
		$pay_data['Notification'] = JFactory::getApplication()->input->get('Notification');
		$virtuemart_order_id = $pay_data['orderid'];
		if (!array_key_exists ('orderid', $pay_data) || !isset($pay_data['orderid'])) {
			return NULL; // Another method was selected, do nothing
		}
		if($pay_data['Success']!='True') {
			return;
		}
		if($pay_data['Notification']!='MerchantPay') {
			return;
		}
		if(!$virtuemart_order_id) return;
		$payment = $this->getDataByOrderId($virtuemart_order_id);
		$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		// для предотвращения подмены данных злоумышленником, проверим правильность запросом к payture
		$ar = array();
		$ar['Key'] = $method->merchantkey;
		$ar['OrderId'] = $virtuemart_order_id;
		$this->paystate='';
		$this->curlerror='';
		$this->doCurl($method->server.'apim/PayStatus', $ar, 'paystatus');
		if($this->paystate=='Charged') {
			if (!class_exists('VirtueMartModelOrders'))
			{
				require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
			}
			$order_model = new VirtueMartModelOrders();
			$order_info = $order_model->getOrder($virtuemart_order_id);
			$new_status = $method->status_success;
			if($order_info['details']['BT']->order_status!=$new_status) {
				$order = array();
				$order['order_status'] = $new_status;
				$order['customer_notified'] =1;
				$order['comments']='payture';
				$order_model->updateStatusForOneOrder($virtuemart_order_id, $order, true);
			}
			jexit('OK');
		}
		return;
/*
		
		$sum = $pay_data['Amount'];

		if (!isset($method->payment_currency) || !$method->payment_currency)
			$this->getPaymentCurrency($method);
		if (!class_exists('CurrencyDisplay'))
			require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
		$paymentCurrency        = CurrencyDisplay::getInstance($method->payment_currency);
		$order_model  = new VirtueMartModelOrders();
		$order_info   = $order_model->getOrder($virtuemart_order_id);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order_info['details']['BT']->order_total, false), 2);	

		if ($sum==$totalInPaymentCurrency)
		{
			$new_status = $method->status_success;
			if($order_info['details']['BT']->order_status!=$new_status) {
				$order = array();
				$order['order_status'] = $new_status;
				$order['customer_notified'] =1;
				$order['comments']='payture';
				$order_model->updateStatusForOneOrder($virtuemart_order_id, $order, true);
			}

			echo 'OK ' . $virtuemart_order_id;
			jexit();
		}
		else {
			echo 'error signature or sum';
			jexit();
		}
		return true; */
    }    
    
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
		return $this->onStoreInstallPluginTable($jplugin_id);
    }
    
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
		return $this->OnSelectCheck($cart);
    }
    
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		$this->cart = $cart;
		return $this->displayListFE($cart, $selected, $htmlIn);
    }
	
	public function getPluginHtml($plugin, $selectedPlugin, $pluginSalesPrice){
		if(isset($this->cart->products) && count($this->cart->products) <= 0) return;
		$pluginmethod_id = $this->_idName;
		$pluginName = $this->_psType . '_name';
		if ($selectedPlugin == $plugin->$pluginmethod_id) {
			$checked = 'checked="checked"';
		} else {
			$checked = '';
		}

		if (!class_exists ('CurrencyDisplay')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
		}
		$currency = CurrencyDisplay::getInstance ();
		$costDisplay = "";
		if ($pluginSalesPrice) {
			$costDisplay = $currency->priceDisplay ($pluginSalesPrice);
			$costDisplay = '<span class="' . $this->_type . '_cost"> (' . JText::_ ('COM_VIRTUEMART_PLUGIN_COST_DISPLAY') . $costDisplay . ")</span>";
		}
		$s = '';

		$html = '<input type="radio" name="' . $pluginmethod_id . '" id="' . $this->_psType . '_id_' . $plugin->$pluginmethod_id . '"   value="' . $plugin->$pluginmethod_id . '" ' . $checked . ">\n"
			. '<label for="' . $this->_psType . '_id_' . $plugin->$pluginmethod_id . '">' . '<span class="' . $this->_type . '">' . $plugin->$pluginName . $costDisplay . $s. "</span></label>\n";

		return $html; 		
	}
	
    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }
    
    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
	 	$this->getPaymentCurrency($method);

		$paymentCurrencyId = $method->payment_currency;
    }
    
    function logingActions($params)
    {
    	jimport('joomla.error.log');
    	$options = array(
    		'format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}"
		);
    	$log = JLog::getInstance('payture_events.log.php', $options);
    	$log->addEntry(array('ORDER' => $params['ORDER'],'ACTION' => $params['ACTION']));
    }
    
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }
    
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }
    
    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
		return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
		return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
		return $this->setOnTablePluginParams($name, $id, $table);
    }
	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	
}
